#include <colorcolumn.hpp>
#include <mytree.hpp>

//#include <boost/lambda/bind.hpp>
//using namespace boost::lambda ;

#include <iostream>
using namespace std ;

ColorColumn :: ColorColumn (const Glib::ustring& title, Gtk::TreeView* tree,
		const Gtk::TreeModelColumn <Glib::ustring>& text_column,
		const Gtk::TreeModelColumn < Glib::RefPtr<Gdk::Pixbuf> >& image_column
		)
	: Gtk::TreeViewColumn (title), 
	  m_tree_view (tree), m_text_column (text_column), m_image_column (image_column)
{
	comboRend = Gtk::manage(new CellRendererColor (m_tree_view)) ;
	pixRend = Gtk::manage (new Gtk::CellRendererPixbuf) ;

	Gdk::Color c ;

	c.set_rgb_p (1.0, 0.0, 0.0) ; comboRend->add_color (c, "Red") ;
	c.set_rgb_p (0.0, 1.0, 0.0) ; comboRend->add_color (c, "Green") ;
	c.set_rgb_p (0.0, 0.0, 1.0) ; comboRend->add_color (c, "Blue") ;
	c.set_rgb_p (0.0, 1.0, 1.0) ; comboRend->add_color (c, "Cyan") ;
	c.set_rgb_p (1.0, 0.0, 1.0) ; comboRend->add_color (c, "Magenta") ;
	c.set_rgb_p (1.0, 1.0, 0.0) ; comboRend->add_color (c, "Yellow") ;

	pack_start (*pixRend, false) ;
	pack_start(*comboRend);

	set_spacing (10) ;

	add_attribute (comboRend->property_text(), m_text_column) ;
	add_attribute (pixRend->property_pixbuf(), m_image_column) ;

//	MyTree* my_tree ;
//	if ((my_tree = dynamic_cast<MyTree*> (m_tree_view)))
//	{
//		comboRend->signal_edited().connect (sigc::mem_fun (*my_tree,
//					&MyTree::combo_renderer_edited)) ;
//	}
//
//	comboRend->signal_color_changed().connect (boost::lambda::bind
//			(&ColorColumn :: change_color, this, _1, _2)) ;
}

void ColorColumn :: change_color (const Glib::ustring& path, const Gdk::Color& c)
{
//	m_colorSignal (path, c) ;
}

ColorColumn :: ~ColorColumn ()
{
}
